unit Basis;

interface

const
  h = 0.01;
  Left = 0;
  Right = 1;
  lenght = (Right-Left)/h;
  bool = Round(lenght)<>Trunc(lenght);
  n = Round((Right-Left)/h) + byte(bool);

type
  Float = Extended;
  TMathFunc = function(x :Float) :Float;
  TVector = array [0..n] of Float;

const
  Param :Float= 0;

function x(i :Float) :Float;

function k(x :Float) :Float;
function q(x :Float) :Float;
//function k_1(x,t :Float) :Float;
function f(x :Float) :Float;

function mu1(t :Float) :Float;
function mu2(t :Float) :Float;

function Exact(i :Float) :Float;

function FToS(x :Float) :String;

implementation

uses SysUtils;

function func(x :Float) :Float;
begin
  Result := exp(-sqr(Param)*(x-Left));
end;

function x(i :Float) :Float;
begin
  Result := Left + i*h;
end;

function mu1(t :Float) :Float; //kr. usl. y[0]
begin
  Result := 1;
end;

function mu2(t :Float) :Float; //kr. usl. y[n]
begin
  Result := 1 + exp(Param);
end;

function q(x :Float) :Float;
begin
  Result := -sqr(Param);
end;

function k(x :Float) :Float;
begin
  Result := 1;
end;
{
function k_1(x,t :Float) :Float;
begin
  Result := 1/k(x,t);
end;
}
function f(x :Float) :Float;
begin
  Result := -sqr(Param)*x;
end;

function FToS(x :Float) :String;
begin
  DecimalSeparator := '.';
  Result := FloatToStrF(x,ffFixed,18,6);
end;

function Exact(i :Float) :Float;
var z :Float;
begin
  z := x(i);
  Result := exp(Param*z) + z;
end;

end.
