unit Differences;

interface

uses Basis;

function  Int(f :TMathFunc; x,h :Float) :Float;

function  DifL(f :TMathFunc; x,h :Float) :Float;
function  DifR(f :TMathFunc; x,h :Float) :Float;
function  DifC(f :TMathFunc; x,h :Float) :Float;
function  Dif2(f :TMathFunc; x,h :Float) :Float;

implementation

function  Int(f :TMathFunc; x,h :Float) :Float;
begin
  Result := h*f(x+h/2);
end;

function  DifL(f :TMathFunc; x,h :Float) :Float;
begin
  Result := (f(x) - f(x-h))/h;
end;

function  DifR(f :TMathFunc; x,h :Float) :Float;
begin
  Result := (f(x+h) - f(x))/h;
end;

function  DifC(f :TMathFunc; x,h :Float) :Float;
begin
  Result := (f(x+h) - f(x-h))/(2*h);
end;

function  Dif2(f :TMathFunc; x,h :Float) :Float;
begin
  Result := (f(x+h) + f(x-h) - 2*f(x))/sqr(h);
end;

end.
